-- .torrent file
-- (c) FSC, 2007

-- *******************************************************************************************************
-- * I wonder how sick and perverted one must be in order to invent such a disgustingly ugly "format"... *
-- *******************************************************************************************************

--
-- get indicator character
--
function GetIndicator()
    return ReadBytes(1).Data
end

--
-- get string terminated by given character and skip that character
--
function GetTerminatedString(chr)
    local CharPos = FindMasked8(string.byte(chr))
    if not CharPos then error("Could not find '" .. string.sub(chr, 1, 1) .. "' terminated string") end
    local Len = CharPos - GetFilePosition().Offset
    if Len == 0 then
        SkipBytes(1)
        return ""
    end
    local Data = ReadBytes(Len)
    SkipBytes(1)
    return Data.Data
end

--
-- get number terminated with given character
--
function GetInteger(chr)
    local CurPos = GetFilePosition().Offset
    local Str = GetTerminatedString(chr)
    local Num = tonumber(Str)
    if Num then return Num end
    error("Invalid number at address " .. CurPos .. ": " .. Str)
end

--
-- print integer value that is encoded as i1234e. Checks for special case of "creation date" dictionary entry
--
function TorrentInteger(KeyName)
    local Num = GetInteger('e')
    if KeyName and KeyName == "creation date" then Num = DecodeCreationDate(Num) end
    PrintNumber(Num)
end

--
-- get string that is encoded as 4:spam
--
function TorrentString()
    local Len = GetInteger(':')
    if Len == 0 then return "", Len end
    return ReadBytes(Len).Data, Len
end

--
-- print list like ['spam', 'eggs']
--
function TorrentList()
    CrLf()
    StartFolding()
    PrintPunctuation("[")
    IncIndent()
    CrLf()

    local NeedComma = false
    
    while true do
        local Char = GetIndicator()
        if Char == 'e' then break end
        if NeedComma then CrLf() end
        TorrentElement(Char)
        NeedComma = true
    end

    DecIndent()
    CrLf()
    PrintPunctuation("]")
    EndFolding()
end

--
-- print dictionary like {'cow': 'moo', 'spam': 'eggs'} or {'spam': ['a', 'b']}
--
function TorrentDictionary()
    CrLf()
    StartFolding()
    PrintPunctuation("{")
    IncIndent()
    CrLf()

    local NeedComma = false
    
    while true do
        local Char = GetIndicator()
        if Char == 'e' then break end
        if NeedComma then CrLf() end
        -- keys must be strings
        if not IsString(Char) then error("Invalid key in dictionary (not a string)", 0) end
        SkipBytes(-1)
        local Name = TorrentString()
        PrintName(Name)
        AlignToColumn(40)
        PrintPunctuation("= ")
        TorrentElement(GetIndicator(), Name)
        NeedComma = true
    end
    DecIndent()
    CrLf()
    PrintPunctuation("}")
    EndFolding()
end

--
-- check if Char defines a string
--
function IsString(chr)
    return '0' <= chr and chr <= '9'
end

--
-- show string as binary dump
--
function Dump(str)
    local LenStr = string.len(str)
    local Len = math.min(LenStr, 0x80)
    local OutStr = ""
    for i = 1, Len do
        OutStr = OutStr .. string.format("%02X ", string.byte(str, i))
    end
    if Len < LenStr then OutStr = OutStr .. "..." end
    return OutStr
end

--
-- process "creation date" field
--
local MonthTable = { "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" }

function DecodeCreationDate(Tim)
    local x = DecodeUnixTime(Tim)
    if not x then return Tim end
    return string.format("%d %s %d %d:%02d:%02d", x.Day, MonthTable[x.Month], x.Year, x.Hour, x.Minute, x.Second)
end

--
-- decode UTF8 string if necessary (did I say that torrent creaters are idiots?...)
--
local IsUTF8 = false

function UnUTF8(Str)
    if IsUTF8 then return StringFromUTF8(Str) end
    return Str
end

--
-- process strings. Recognizes know keys like "pieces", "ed2k" etc
--
function ProcessString(KeyName)
    local Str, Len = TorrentString()
    if KeyName then
        -- this is a string in a dictionary
        if KeyName == "ed2k" or KeyName == "sha1" or KeyName == "md5sum" then return Dump(Str) end
        if KeyName == "pieces" then
            PrintNumber("... ")
            PrintMLComment(Len .. " bytes of hash data")
            return ""
        end
        -- yeah, .torrent file creators are mostly idiots. They do NOT read specifications and
        -- therefore don't know that ALL strings must be UTF-8 encoded. Instead, they think
        -- that strings are UTF-8 encoded only if they explicitly state "encoding = UTF-8"
        if KeyName == "encoding" then
            if Str == "UTF-8" then
                IsUTF8 = true
            end
        end
    end
    if Len > 0 then return UnUTF8(Str) end
    return Str
end

--
-- analyze bencoding indicator character (l, d, i, num)
--
function TorrentElement(Char, KeyName)
    if Char == 'i'      then return TorrentInteger(KeyName)         end
    if Char == 'l'      then return TorrentList()                   end
    if Char == 'd'      then return TorrentDictionary()             end
    
    if IsString(Char) then
        -- indicator character is a part of the string so we have to rewind
        SkipBytes(-1)
        PrintNumber(ProcessString(KeyName))
        return
    end
    
    error("Unknown bencoding indicator character: '" .. Char .. "'")
end

function BDecode()
    while BytesTillEOF() > 0 do
        local Char = GetIndicator()
    
        if Char == 'e' then return end
        TorrentElement(Char)
    end
end

Dec()
NameWidth = 20

BlockComment("\r...and may Holy Knuth, Wirth and Gates chastise those who concoct file formats like this one...\r\r")
BDecode()
